package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPQUIT_OIVPM07I {
    public @Getter @Builder.Default String FILLER1 = StringUtils
            .repeat(' ', 12);
    public @Getter @Setter int DATEL;
    public @Getter @Builder.Default String DATEF = StringUtils.repeat(' ', 1);

    public String getDATEA() {
        return DATEF;
    }

    public void setDATEA(String var) {
        DATEF = var;
    }

    public @Getter @Builder.Default String DATEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int TERML;
    public @Getter @Builder.Default String TERMF = StringUtils.repeat(' ', 1);

    public String getTERMA() {
        return TERMF;
    }

    public void setTERMA(String var) {
        TERMF = var;
    }

    public @Getter @Builder.Default String TERMI = StringUtils.repeat(' ', 4);
    public @Getter @Setter int TIMEL;
    public @Getter @Builder.Default String TIMEF = StringUtils.repeat(' ', 1);

    public String getTIMEA() {
        return TIMEF;
    }

    public void setTIMEA(String var) {
        TIMEF = var;
    }

    public @Getter @Builder.Default String TIMEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int ENDML;
    public @Getter @Builder.Default String ENDMF = StringUtils.repeat(' ', 1);

    public String getENDMA() {
        return ENDMF;
    }

    public void setENDMA(String var) {
        ENDMF = var;
    }

    public @Getter @Builder.Default String ENDMI = StringUtils.repeat(' ', 36);
    public @Getter @Setter int MSGL;
    public @Getter @Builder.Default String MSGF = StringUtils.repeat(' ', 1);

    public String getMSGA() {
        return MSGF;
    }

    public void setMSGA(String var) {
        MSGF = var;
    }

    public @Getter @Builder.Default String MSGI = StringUtils.repeat(' ', 76);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setFILLER1(String source) {
        FILLER1 = StringUtils.truncate(StringUtils.rightPad(source, 12), 12);
    }

    public String getStringDATEL() {
        return intFormatWithSign.apply((long) DATEL, "0000");
    }

    public void setDATEF(String source) {
        DATEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDATEI(String source) {
        DATEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringTERML() {
        return intFormatWithSign.apply((long) TERML, "0000");
    }

    public void setTERMF(String source) {
        TERMF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTERMI(String source) {
        TERMI = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public String getStringTIMEL() {
        return intFormatWithSign.apply((long) TIMEL, "0000");
    }

    public void setTIMEF(String source) {
        TIMEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTIMEI(String source) {
        TIMEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringENDML() {
        return intFormatWithSign.apply((long) ENDML, "0000");
    }

    public void setENDMF(String source) {
        ENDMF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setENDMI(String source) {
        ENDMI = StringUtils.truncate(StringUtils.rightPad(source, 36), 36);
    }

    public String getStringMSGL() {
        return intFormatWithSign.apply((long) MSGL, "0000");
    }

    public void setMSGF(String source) {
        MSGF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setMSGI(String source) {
        MSGI = StringUtils.truncate(StringUtils.rightPad(source, 76), 76);
    }

    public static OIVPQUIT_OIVPM07I createDefaultValueInstance() {
        return new OIVPQUIT_OIVPM07I.builder().build();
    }

    @Override
    public String toString() {
        return FILLER1 + String.valueOf(getDATEL()) + getDATEF() + getDATEI()
                + String.valueOf(getTERML()) + getTERMF() + getTERMI()
                + String.valueOf(getTIMEL()) + getTIMEF() + getTIMEI()
                + String.valueOf(getENDML()) + getENDMF() + getENDMI()
                + String.valueOf(getMSGL()) + getMSGF() + getMSGI();
    }
}
